// SDO_PDO_ISRDlg.cpp : @
//

#include "stdafx.h"
#include "SDO_PDO_ISR.h"
#include "SDO_PDO_ISRDlg.h"
#include "..\..\lib\cpm100u.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  App About ϥ CAboutDlg ܤ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ܤ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 䴩

// {X@
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSDO_PDO_ISRDlg ܤ

#define DI_MODULE_SLOT	2
#define DI_TOTAL_CH		16

#define DO_MODULE_SLOT  1
#define DO_TOTAL_CH		16

BYTE BOARD=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD ret;
CString errstr;

CString ISR_Str;


CSDO_PDO_ISRDlg::CSDO_PDO_ISRDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSDO_PDO_ISRDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSDO_PDO_ISRDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_COMBO_BOARD, m_board);
	DDX_Control(pDX, IDC_LIST_MONITOR, m_monitor);
	DDX_Control(pDX, IDC_COMBO_MASTERID, m_masterid);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
}

BEGIN_MESSAGE_MAP(CSDO_PDO_ISRDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_BOARD, OnSelchangeComboBoard)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_MASTERID, OnSelchangeComboMasterid)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
END_MESSAGE_MAP()


// CSDO_PDO_ISRDlg TBz`

BOOL CSDO_PDO_ISRDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// N [...] \[JtΥ\C

	// IDM_ABOUTBOX btΩROd򤧤C
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w

	for(WORD i=1;i<128;i++){
		CString Items;

		Items.Format(_T("%03d"), i);
		m_masterid.AddString(Items);
	}

	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_masterid.EnableWindow(TRUE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_masterid.SetCurSel(0);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);

	m_monitor.ResetContent();
	
	ISR_Str.Format(_T(""));

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

void CSDO_PDO_ISRDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// pGN̤pƫs[JzܤAzݭnUC{XA
// HKøsϥܡCϥΤ/˵Ҧ MFC ε{A
// ج[|۰ʧ@~C

void CSDO_PDO_ISRDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // øs˸me

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NϥܸmΤݯx
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// yøϥ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ϥΪ̩즲̤pƵɡA
// tΩIsoӥ\oܡC
HCURSOR CSDO_PDO_ISRDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSDO_PDO_ISRDlg::OnSelchangeComboBoard() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CSDO_PDO_ISRDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();
}

void CSDO_PDO_ISRDlg::OnSelchangeComboMasterid() 
{
	// TODO: Add your control notification handler code here
	NODE = m_masterid.GetCurSel()+1;
}

// Note: The program-time of the ISR function do not too long. 
void RSDOISR()
{
	WORD Ret;
	BYTE BoardNo, SubIndex, RLen;
	WORD Index;
	BYTE RData[4] = {0};
	DWORD Abort = 0;

	Ret = CPM100_GetMasterReadSDOEvent(&BoardNo, &Index, &SubIndex);
	if(!Ret){
		switch(Index){
		case 0x6000:	// Read DI (For CANopen SPC 401)
			{
				BYTE DI_Value=0;

				switch(SubIndex){
				case 0x00:
					{
						// DI entry number
						RLen = 1;
						RData[0] = 0x02;	// Ex: ch0~ch15, total 2-bytes (16-bits) DI data.
					}
					break;
				case 0x01:
					{
						RLen = 1;
						DI_Value = 0;

						// Read DI value of ch0 ~ ch7
						//////////////////////////////////////////////
						//  Write user's "Read DI Data function" here
	                                    

						//////////////////////////////////////////////

						RData[0] = DI_Value;
					}
					break;
				case 0x02:
					{
						RLen = 1;
						DI_Value = 0;

						// Read DI value of ch8 ~ ch15
						//////////////////////////////////////////////
						//  Write user's "Read DI Data function" here


						//////////////////////////////////////////////
						
						RData[0] = DI_Value;
					}
					break;
				default:
					{
						Abort = 0x06090011;

						// Abort: Sub-index does not exist.
						RLen = 4;
						memcpy(RData, &Abort, RLen);
					}
					break;
				}
			}
			break;
		case 0x6200:	// Read DO  (For CANopen SPC 401)
			{
				BYTE DO_Value=0;

				switch(SubIndex){
				case 0x00:
					{
						// DO entry number
						RLen = 1;
						RData[0] = 0x02;   // Ex: ch0~ch15, total 2-bytes (16-bits) DO data.
					}
					break;
				case 0x01:
					{
						RLen = 1;
						DO_Value = 0;

						// Read DO value of ch0 ~ ch7
						//////////////////////////////////////////////
						//  Write user's "Read DO Data function" here


						//////////////////////////////////////////////
						RData[0] = DO_Value;
					}
					break;
				case 0x02:
					{
						RLen = 1;
						DO_Value = 0;

						// Read DO value of ch8 ~ ch15
						//////////////////////////////////////////////
						//  Write user's "Read DO Data function" here


						//////////////////////////////////////////////
						RData[0] = DO_Value;
					}
					break;
				default:
					{
						Abort = 0x06090011;

						// Abort: Sub-index does not exist.
						RLen = 4;
						memcpy(RData, &Abort, RLen);
					}
					break;
				}
			}
			break;
		default:
			{
				Abort = 0x06020000;

				// Abort: Object does not exist.
				RLen = 4;
				memcpy(RData, &Abort, RLen);
			}
			break;
		}

		{
			WORD i;
			CString TempStr;

			if(Abort == 0){
				CPM100_ResponseMasterSDO(BoardNo, 0, Index, SubIndex, RLen, RData);
				TempStr = "SDO Read";
			}
			else{
				CPM100_SDOAbortTransmit(BoardNo, NODE, Index, SubIndex, Abort, BlockMode);
				TempStr = "SDO Abort";
			}


			TempStr.Format(_T("%s %04X-%02X:"),TempStr,Index,SubIndex);
			for(i=0;i<RLen;i++){
				TempStr.Format(_T("%s %02X"),TempStr,RData[i]);
			}

			ISR_Str = TempStr;
		}

	}
	return;
}

void WSDOISR()
{
	WORD Ret;
	BYTE BoardNo, SubIndex, WLen;
	WORD Index;
	BYTE WData[4] = {0};
	DWORD Abort = 0;

	Ret = CPM100_GetMasterWriteSDOEvent(&BoardNo, &Index, &SubIndex, &WLen, WData);
	if(!Ret){
		switch(Index){
		case 0x6200:	// Write DO (For CANopen SPC 401)
			{
				if(WLen != 1){
					Abort = 0x06070010;

					// Abort: Data type does not match, length of service parameter does not match
					WLen = 4;
					memcpy(WData, &Abort, WLen);
				}

				switch(SubIndex){
				case 0x00:
					{
						Abort = 0x06010002;

						// Abort: Attempt to write a read only object
						WLen = 4;
						memcpy(WData, &Abort, WLen);
					}
					break;
				case 0x01:
					{
						// Ouput DO value of ch0 ~ ch7
						//////////////////////////////////////////////
						//  Write user's "Output DO Data function" here


						//////////////////////////////////////////////
					}
					break;
				case 0x02:
					{
						// Change DO value of ch8 ~ ch15
						//////////////////////////////////////////////
						//  Write user's "Output DO Data function" here


						//////////////////////////////////////////////
					}
					break;
				default:
					{
						Abort = 0x06090011;

						// Abort: Sub-index does not exist.
						WLen = 4;
						memcpy(WData, &Abort, WLen);
					}
					break;
				}
			}
			break;
		default:
			{
				Abort = 0x06020000;

				// Abort: Object does not exist.
				WLen = 4;
				memcpy(WData, &Abort, WLen);
			}
			break;
		}

		{
			WORD i;
			CString TempStr;

			if(Abort == 0){
				CPM100_ResponseMasterSDO(BoardNo, 1, Index, SubIndex, 0, NULL);
				TempStr.Format(_T("SDO Write %04X-%02X: OK"),Index,SubIndex);
			}
			else{
				CPM100_SDOAbortTransmit(BoardNo, NODE, Index, SubIndex, Abort, BlockMode);
				TempStr.Format(_T("SDO Abort %04X-%02X:"),Index,SubIndex);

				for(i=0;i<WLen;i++){
					TempStr.Format(_T("%s %02X"),TempStr,WData[i]);
				}
			}

			ISR_Str = TempStr;
		}
	}
	return;
}

void RXPDOISR()
{
	WORD Ret, i;
	BYTE BoardNo, WLen;
	WORD CobId;
	BYTE WData[8] = {0};
	CString TempStr;

	Ret = CPM100_GetMasterRxPDOEvent(&BoardNo, &CobId, &WLen, WData);
	if(!Ret){
		if(CobId == 0x200 + NODE){
			if(WLen >= 2){   // Ex: If user has 2-bytes DO data.
				// Output DO value of ch0 ~ ch15
				//////////////////////////////////////////////
				//  Write user's "Output DO Data function" here


				//////////////////////////////////////////////

				TempStr.Format(_T("PDO %03X Output:"),CobId);
				for(i=0;i<WLen;i++){
					TempStr.Format(_T("%s %02X"),TempStr,WData[i]);
				}

				ISR_Str = TempStr;
			}
		}
	}
}

void REMOTEPDOISR()
{
	WORD Ret, i;
	BYTE BoardNo, RLen;
	WORD CobId;
	BYTE RData[8] = {0};
	CString TempStr;

	Ret = CPM100_GetMasterRemotePDOEvent(&BoardNo, &CobId);
	if(!Ret){
		if(CobId == 0x180 + NODE){
			// Ex: If user has 2-bytes DI data.
			RLen = 2;
			// Read DI value of ch0 ~ ch15
			//////////////////////////////////////////////
			//  Write user's "Read DI Data function" here


			//////////////////////////////////////////////

			TempStr.Format(_T("PDO %03X Remote:"),CobId);
			for(i=0;i<RLen;i++){
				TempStr.Format(_T("%s %02X"),TempStr,RData[i]);
			}

			ISR_Str = TempStr;
		}
	}
}

void CSDO_PDO_ISRDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	// Master initialized with a node id
	ret = CPM100_InitMaster(BOARD, NODE, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_masterid.EnableWindow(FALSE);

		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.EnableWindow(TRUE);
		m_btn_shutdown.ShowWindow(SW_SHOW);

		// Install SDO read ISR
		ret = CPM100_InstallReadSDOISR(BOARD, RSDOISR);
		if(ret){
			errstr.Format(_T("Install Read SDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// Initial SDO write ISR
		ret = CPM100_InstallWriteSDOISR(BOARD, WSDOISR);
		if(ret){
			errstr.Format(_T("Install Write SDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// Install PDO output ISR
		ret = CPM100_InstallRxPDOISR(BOARD, RXPDOISR);
		if(ret){
			errstr.Format(_T("Install output PDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// The "EntryUse" parameter and "EntryData" parameter are useless
		// when the PDO had been installed to master. 
		CPM100_InstallPDO_List(BOARD, NODE, 0x200+NODE, 0, 1, 255, 0, 0, NULL, BlockMode);

		// Install PDO remote ISR
		ret = CPM100_InstallRemotePDOISR(BOARD, REMOTEPDOISR);
		if(ret){
			errstr.Format(_T("Install remote PDO ISR Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}

		// The "EntryUse" parameter and "EntryData" parameter are useless
		// when the PDO had been installed to master.
		CPM100_InstallPDO_List(BOARD, NODE, 0x180+NODE, 1, 1, 255, 0, 0, NULL, BlockMode);

		SetTimer(123,100,NULL);
	}
}

void CSDO_PDO_ISRDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_ShutdownMaster(BOARD);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_masterid.EnableWindow(TRUE);

		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_masterid.SetCurSel(0);

		m_monitor.ResetContent();

		KillTimer(123);
	}
}

void CSDO_PDO_ISRDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_monitor.ResetContent();
}

void CSDO_PDO_ISRDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	KillTimer(123);
	CPM100_ShutdownMaster(BOARD);
}

void CSDO_PDO_ISRDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(ISR_Str != ""){
		m_monitor.AddString(ISR_Str);
		ISR_Str = "";
    }

	CDialog::OnTimer(nIDEvent);
}
