// SYNC_ProtocolDlg.cpp : @
//

#include "stdafx.h"
#include "SYNC_Protocol.h"
#include "SYNC_ProtocolDlg.h"
#include "..\..\lib\cpm100u.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  App About ϥ CAboutDlg ܤ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ܤ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 䴩

// {X@
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSYNC_ProtocolDlg ܤ


BYTE BOARD=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;

BYTE ISADD[128]={0};

CSYNC_ProtocolDlg::CSYNC_ProtocolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSYNC_ProtocolDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSYNC_ProtocolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_LIST_SYNCLIST, m_synclist);
	DDX_Control(pDX, IDC_EDIT_SYNCTIMES, m_synctimes);
	DDX_Control(pDX, IDC_EDIT_SYNCTIMER, m_synctimer);
	DDX_Control(pDX, IDC_EDIT_SYNCID, m_syncid);
	DDX_Control(pDX, IDC_COMBO_BOARD, m_board);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SENDSYNC, m_btn_sendsync);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_CHANGESYNC, m_btn_changesyncid);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
}

BEGIN_MESSAGE_MAP(CSYNC_ProtocolDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_BOARD, OnSelchangeComboBoard)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_CHANGESYNC, OnButtonChangesync)
	ON_BN_CLICKED(IDC_BUTTON_SENDSYNC, OnButtonSendsync)
END_MESSAGE_MAP()


// CSYNC_ProtocolDlg TBz`

void CSYNC_ProtocolDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_btn_changesyncid.EnableWindow(FALSE);
		m_btn_sendsync.EnableWindow(FALSE);
		m_syncid.EnableWindow(FALSE);
		m_synctimer.EnableWindow(FALSE);
		m_synctimes.EnableWindow(FALSE);
	}
	else{
		m_btn_changesyncid.EnableWindow(TRUE);
		m_btn_sendsync.EnableWindow(TRUE);
		m_syncid.EnableWindow(TRUE);
		m_synctimer.EnableWindow(TRUE);
		m_synctimes.EnableWindow(TRUE);
	}
}

BOOL CSYNC_ProtocolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// N [...] \[JtΥ\C

	// IDM_ABOUTBOX btΩROd򤧤C
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w

	for(WORD i=1;i<128;i++){
		CString Items;

		Items.Format(_T("%03d"), i);
		m_node.AddString(Items);
	}

	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_addnode.ShowWindow(SW_SHOW);
	m_btn_removenode.EnableWindow(FALSE);
	m_btn_removenode.ShowWindow(SW_HIDE);

	Enable_Disable(FALSE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);

	m_syncid.LimitText(3);
	m_synctimer.LimitText(5);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

void CSYNC_ProtocolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// pGN̤pƫs[JzܤAzݭnUC{XA
// HKøsϥܡCϥΤ/˵Ҧ MFC ε{A
// ج[|۰ʧ@~C

void CSYNC_ProtocolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // øs˸me

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NϥܸmΤݯx
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// yøϥ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ϥΪ̩즲̤pƵɡA
// tΩIsoӥ\oܡC
HCURSOR CSYNC_ProtocolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


BOOL CSYNC_ProtocolDlg::PreTranslateMessage(MSG* pMsg)
{
	if(pMsg->message == WM_CHAR)
	{
		if(pMsg->hwnd == m_syncid.m_hWnd){
			if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
				((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
				((pMsg->wParam >= 0x61) && (pMsg->wParam <= 0x66)) ||
				 (pMsg->wParam == 0x08) ){
			}
			else{
				return true;
			}
		}
		else{
			if( ((pMsg->wParam >= 0x30) && (pMsg->wParam <= 0x39)) || 
				((pMsg->wParam >= 0x41) && (pMsg->wParam <= 0x46)) ||
				 (pMsg->wParam == 0x08) ){
			}
			else{
				return true;
			}
		}
	}

	return CDialog::PreTranslateMessage(pMsg);
}

void CSYNC_ProtocolDlg::OnSelchangeComboBoard() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CSYNC_ProtocolDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CSYNC_ProtocolDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;

	if(ISADD[NODE]){
		WORD SyncId=0;

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);

		Enable_Disable(TRUE);

		ret = CPM100_GetSYNCID(BOARD, NODE, &SyncId, BlockMode);
		if(!ret){
			CString Temp_Str;

			Temp_Str.Format(_T("%X"),SyncId);
			m_syncid.SetWindowText(Temp_Str);
		}
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);

		Enable_Disable(FALSE);

		m_syncid.SetWindowText(_T(""));
	}
}

void CSYNC_ProtocolDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_InitMaster(BOARD, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.ShowWindow(SW_SHOW);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CSYNC_ProtocolDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_ShutdownMaster(BOARD);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		m_node.SetCurSel(0);
		m_syncid.SetWindowText(_T(""));
		m_synclist.ResetContent();

		Enable_Disable(FALSE);

		memset(ISADD,0,128);
	}
}

void CSYNC_ProtocolDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_AddNode(BOARD, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		WORD SyncId=0;

		ISADD[NODE] = 1;

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_removenode.ShowWindow(SW_SHOW);

		Enable_Disable(TRUE);

		ret = CPM100_GetSYNCID(BOARD, NODE, &SyncId, BlockMode);
		if(!ret){
			CString Temp_Str;

			Temp_Str.Format(_T("%X"),SyncId);
			m_syncid.SetWindowText(Temp_Str);
		}
	}
}

void CSYNC_ProtocolDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_RemoveNode(BOARD, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		ISADD[NODE] = 0;

		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		Enable_Disable(FALSE);

		m_syncid.SetWindowText(_T(""));
		UpdataList();
	}
}

void CSYNC_ProtocolDlg::OnButtonChangesync() 
{
	wchar_t *end_str;
	CString TempStr;
	WORD SyncId;
	// TODO: Add your control notification handler code here
	
	m_syncid.GetWindowText(TempStr);
	SyncId = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	ret = CPM100_ChangeSYNCID(BOARD, NODE, SyncId, BlockMode);
	if(ret){
		errstr.Format(_T("ChangeSYNCID Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}

	ret = CPM100_GetSYNCID(BOARD, NODE, &SyncId, BlockMode);
	if(!ret){
		CString Temp_Str;

		Temp_Str.Format(_T("%X"),SyncId);
		m_syncid.SetWindowText(Temp_Str);
	}
}

void CSYNC_ProtocolDlg::OnButtonSendsync() 
{
	CString TempStr;
	wchar_t *end_str;
	WORD SyncId, Timer; 
	DWORD Times;
	// TODO: Add your control notification handler code here

	m_syncid.GetWindowText(TempStr);
	SyncId = (WORD)wcstol(TempStr.AllocSysString(),&end_str,16);

	m_synctimer.GetWindowText(TempStr);
	Timer = (WORD)wcstol(TempStr.AllocSysString(),&end_str,10);

	m_synctimes.GetWindowText(TempStr);
	Times = (WORD)wcstol(TempStr.AllocSysString(),&end_str,10);

	ret = CPM100_SendSYNCMsg(BOARD, SyncId, Timer, Times, BlockMode);
	if(ret){
		errstr.Format(_T("SendSYNCMsg Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		UpdataList();
	}
}

void CSYNC_ProtocolDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	CPM100_ShutdownMaster(BOARD);
}

void CSYNC_ProtocolDlg::UpdataList()
{
	WORD a_SyncId[5], a_Timer[5]; 
	DWORD a_Times[5];

	m_synclist.ResetContent();
	ret = CPM100_GetCyclicSYNCInfo(BOARD, a_SyncId, a_Timer, a_Times, BlockMode);
	if(!ret){
		WORD i;
		CString Temp_Str;

		for(i=0;i<5;i++){
			if(a_SyncId[i] == 0) break;

			Temp_Str.Format(_T("SYNC: %X , Timer: %u , Times: %lu"),a_SyncId[i],a_Timer[i],a_Times[i]);
			m_synclist.AddString(Temp_Str);
		}
	}
}
