// Scan_NodeDlg.cpp : @
//

#include "stdafx.h"
#include "Scan_Node.h"
#include "Scan_NodeDlg.h"
#include "..\..\lib\cpm100u.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  App About ϥ CAboutDlg ܤ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ܤ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 䴩

// {X@
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CScan_NodeDlg ܤ

BYTE BOARD=0;
BYTE BAUD=0;
BYTE NODE=0;

BYTE BlockMode = 1;

WORD DelayTime=0;
WORD ret;
CString errstr;


CScan_NodeDlg::CScan_NodeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CScan_NodeDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CScan_NodeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_LIST_NODELIST, m_nodelist);
	DDX_Control(pDX, IDC_COMBO_BOARD, m_board);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SCAN, m_btn_scan);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
}

BEGIN_MESSAGE_MAP(CScan_NodeDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_BOARD, OnSelchangeComboBoard)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SCAN, OnButtonScan)
END_MESSAGE_MAP()


// CScan_NodeDlg TBz`

BOOL CScan_NodeDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// N [...] \[JtΥ\C

	// IDM_ABOUTBOX btΩROd򤧤C
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w

	for(WORD i=1;i<128;i++){
		CString Items;

		Items.Format(_T("%03d"), i);
		m_node.AddString(Items);
	}

	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(FALSE);
	m_btn_shutdown.EnableWindow(SW_HIDE);
	m_btn_scan.EnableWindow(FALSE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_removenode.EnableWindow(FALSE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

void CScan_NodeDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// pGN̤pƫs[JzܤAzݭnUC{XA
// HKøsϥܡCϥΤ/˵Ҧ MFC ε{A
// ج[|۰ʧ@~C

void CScan_NodeDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // øs˸me

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NϥܸmΤݯx
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// yøϥ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ϥΪ̩즲̤pƵɡA
// tΩIsoӥ\oܡC
HCURSOR CScan_NodeDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CScan_NodeDlg::OnSelchangeComboBoard() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CScan_NodeDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CScan_NodeDlg::OnSelchangeComboNode() 
{
	WORD Node_Index;
	TCHAR T_TempStr[10];
	TCHAR *end_str;
	// TODO: Add your control notification handler code here

	if(!m_node.GetCount()) return;

	Node_Index = m_node.GetCurSel();

	// Convert text to Node ID number
	m_node.GetLBText(Node_Index,T_TempStr);
	NODE = (BYTE)wcstoul(T_TempStr,&end_str,10);
}

void CScan_NodeDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_InitMaster(BOARD, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);

		m_btn_initial.EnableWindow(FALSE);
		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.EnableWindow(TRUE);
		m_btn_shutdown.EnableWindow(SW_SHOW);

		m_btn_scan.EnableWindow(TRUE);
	}
}

void CScan_NodeDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_ShutdownMaster(BOARD);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.EnableWindow(TRUE);
		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.EnableWindow(FALSE);
		m_btn_shutdown.EnableWindow(SW_HIDE);

		m_btn_scan.EnableWindow(FALSE);
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_removenode.EnableWindow(FALSE);
	}
}

void CScan_NodeDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_AddNode(BOARD, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE NodeList[16];
		BYTE Flag, Node=0;
		WORD i,j;
		CString NodeNumber;

		ret = CPM100_GetNodeList(BOARD, NodeList, BlockMode);
		if(ret){
			errstr.Format(_T("Node List Get Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
		else{
			m_nodelist.ResetContent();
			// NodeList[0] is node 0 ~ 7
			// NodeList[1] is node 8 ~ 15
			// ...
			// NodeList[15] is node 120 ~ 127
			for(i=0;i<16;i++){
				Flag=1;
				for(j=0;j<8;j++){
					if(NodeList[i] & Flag){
						NodeNumber.Format(_T("Node %03d under controll"),Node);
						m_nodelist.AddString(NodeNumber);
					}
					Node++;
					Flag = Flag << 1;
				}
			}
		}
	}
}

void CScan_NodeDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_RemoveNode(BOARD, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		BYTE NodeList[16];
		BYTE Flag, Node=0;
		WORD i,j;
		CString NodeNumber;

		ret = CPM100_GetNodeList(BOARD, NodeList, BlockMode);
		if(ret){
			errstr.Format(_T("Node List Get Error, = %d"),ret);
			MessageBox(errstr,_T("Error"),MB_OK);
		}
		else{
			m_nodelist.ResetContent();
			// NodeList[0] is node 0 ~ 7
			// NodeList[1] is node 8 ~ 15
			// ...
			// NodeList[15] is node 120 ~ 127
			for(i=0;i<16;i++){
				Flag=1;
				for(j=0;j<8;j++){
					if(NodeList[i] & Flag){
						NodeNumber.Format(_T("Node %03d under controll"),Node);
						m_nodelist.AddString(NodeNumber);
					}
					Node++;
					Flag = Flag << 1;
				}
			}
		}
	}
}

void CScan_NodeDlg::OnButtonScan() 
{
	BYTE NodeList[16];
	BYTE Flag, Node=0;
	WORD i,j;
	CString NodeNumber;
	// TODO: Add your control notification handler code here

	// Set function timeout to 3000 ms
	CPM100_SetFunctionTimeout(BOARD, 3000);

	// Scan total node to check witch nodes are on the CANopen bus
	ret = CPM100_ScanNode(BOARD, 0, 0, NodeList, BlockMode);
	if(ret){
		errstr.Format(_T("Node Scan Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		// Set function timeout to 1000 ms (default value)
		CPM100_SetFunctionTimeout(BOARD, 1000);

		m_node.ResetContent();
		// NodeList[0] is node 0 ~ 7
		// NodeList[1] is node 8 ~ 15
		// ...
		// NodeList[15] is node 120 ~ 127
		for(i=0;i<16;i++){
			Flag=1;
			for(j=0;j<8;j++){
				if(NodeList[i] & Flag){
					NodeNumber.Format(_T("%03d"),Node);
					m_node.AddString(NodeNumber);
				}
				Node++;
				Flag = Flag << 1;
			}
		}

		if(m_node.GetCount()){
			TCHAR T_TempStr[10];
			TCHAR *end_str;

			m_node.EnableWindow(TRUE);
			m_btn_addnode.EnableWindow(TRUE);
			m_btn_removenode.EnableWindow(TRUE);

			// Convert text to Node ID number
			m_node.GetLBText(0,T_TempStr);
			NODE = (BYTE)wcstoul(T_TempStr,&end_str,10);
		}
		else{
			m_node.AddString(_T("None Slave!"));
			m_node.EnableWindow(FALSE);
			m_btn_addnode.EnableWindow(FALSE);
			m_btn_removenode.EnableWindow(FALSE);

			NODE = 0;
		}

		m_node.SetCurSel(0);
	}
}
