// NMT_ProtocolDlg.cpp : @
//

#include "stdafx.h"
#include "NMT_Protocol.h"
#include "NMT_ProtocolDlg.h"
#include "..\..\lib\cpm100u.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  App About ϥ CAboutDlg ܤ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ܤ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 䴩

// {X@
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CNMT_ProtocolDlg ܤ


BYTE BOARD=0;
BYTE BAUD=0;
BYTE NODE=1;
BYTE STA=0x01;

BYTE BlockMode = 1;

CString STA_Str;
CString NMTErr;
CString EMCY;

WORD DelayTime=0;
WORD ret;
CString errstr;

CNMT_ProtocolDlg::CNMT_ProtocolDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNMT_ProtocolDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CNMT_ProtocolDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_EMCYLIST, m_reslist);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_EDIT_LIFEFACTOR, m_lifetime);
	DDX_Control(pDX, IDC_EDIT_HEARTBEAT, m_heartbeat);
	DDX_Control(pDX, IDC_EDIT_GUARDING, m_guardtime);
	DDX_Control(pDX, IDC_EDIT_CONSUMER, m_consumer);
	DDX_Control(pDX, IDC_COMBO_STATUS, m_status);
	DDX_Control(pDX, IDC_COMBO_BOARD, m_board);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SETSTATUS, m_btn_setstate);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_HEARTBEAT, m_btn_heartbeat);
	DDX_Control(pDX, IDC_BUTTON_GUARDING, m_btn_guarding);
	DDX_Control(pDX, IDC_BUTTON_CLEAR, m_btn_clear);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
}

BEGIN_MESSAGE_MAP(CNMT_ProtocolDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_BOARD, &CNMT_ProtocolDlg::OnSelchangeComboBoard)
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, &CNMT_ProtocolDlg::OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, &CNMT_ProtocolDlg::OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_STATUS, &CNMT_ProtocolDlg::OnSelchangeComboStatus)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, &CNMT_ProtocolDlg::OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, &CNMT_ProtocolDlg::OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, &CNMT_ProtocolDlg::OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, &CNMT_ProtocolDlg::OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CNMT_ProtocolDlg::OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_SETSTATUS, &CNMT_ProtocolDlg::OnButtonSetstate)
	ON_BN_CLICKED(IDC_BUTTON_GUARDING, &CNMT_ProtocolDlg::OnButtonGuarding)
	ON_BN_CLICKED(IDC_BUTTON_HEARTBEAT, &CNMT_ProtocolDlg::OnButtonHeartbeat)
END_MESSAGE_MAP()


// CNMT_ProtocolDlg TBz`

void CNMT_ProtocolDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_status.EnableWindow(FALSE);
		m_btn_setstate.EnableWindow(FALSE);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_guarding.EnableWindow(FALSE);
		m_btn_heartbeat.EnableWindow(FALSE);
		m_btn_clear.EnableWindow(FALSE);
		m_guardtime.EnableWindow(FALSE);
		m_lifetime.EnableWindow(FALSE);
		m_heartbeat.EnableWindow(FALSE);
		m_consumer.EnableWindow(FALSE);
	}
	else{
		m_status.EnableWindow(TRUE);
		m_btn_setstate.EnableWindow(TRUE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_guarding.EnableWindow(TRUE);
		m_btn_heartbeat.EnableWindow(TRUE);
		m_btn_clear.EnableWindow(TRUE);
		m_guardtime.EnableWindow(TRUE);
		m_lifetime.EnableWindow(TRUE);
		m_heartbeat.EnableWindow(TRUE);
		m_consumer.EnableWindow(TRUE);
	}
}

BOOL CNMT_ProtocolDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// N [...] \[JtΥ\C

	// IDM_ABOUTBOX btΩROd򤧤C
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w

	for(WORD i=1;i<128;i++){
		CString Items;

		Items.Format(_T("%03d"), i);
		m_node.AddString(Items);
	}

	STA_Str.Format(_T("Operation mode"));

	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_addnode.EnableWindow(FALSE);

	Enable_Disable(FALSE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);
	m_status.SetCurSel(0);

	m_guardtime.LimitText(5);
	m_lifetime.LimitText(3);
	m_heartbeat.LimitText(5);
	m_consumer.LimitText(5);

	m_guardtime.SetWindowText(_T("1000"));
	m_lifetime.SetWindowText(_T("2"));
	m_heartbeat.SetWindowText(_T("1000"));
	m_consumer.SetWindowText(_T("2500"));

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

void CNMT_ProtocolDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// pGN̤pƫs[JzܤAzݭnUC{XA
// HKøsϥܡCϥΤ/˵Ҧ MFC ε{A
// ج[|۰ʧ@~C

void CNMT_ProtocolDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // øs˸me

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NϥܸmΤݯx
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// yøϥ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ϥΪ̩즲̤pƵɡA
// tΩIsoӥ\oܡC
HCURSOR CNMT_ProtocolDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CNMT_ProtocolDlg::PreTranslateMessage(MSG* pMsg)	// Overload PreTranslateMessage
{
	if(pMsg->message == WM_CHAR){	// Check "WM_CHAR" message
		if((pMsg->hwnd == m_guardtime.m_hWnd)||(pMsg->hwnd == m_lifetime.m_hWnd)||(pMsg->hwnd == m_heartbeat.m_hWnd)||(pMsg->hwnd == m_consumer.m_hWnd)){
			if(((pMsg->wParam >= 0x30)&&(pMsg->wParam <= 0x39))||(pMsg->wParam == 0x08)){
				return FALSE;	// pass "0 ~ 9" and "Back"
			}
			else{
				return TRUE;
			}
		}
	}

	return FALSE;
}

void CNMT_ProtocolDlg::OnSelchangeComboBoard() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CNMT_ProtocolDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();
	
	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CNMT_ProtocolDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CNMT_ProtocolDlg::OnSelchangeComboStatus() 
{
	// TODO: Add your control notification handler code here
	switch(m_status.GetCurSel()){
	case 0:		// Operation mode
		STA = 0x01;
		STA_Str = "Operation mode";
		break;
	case 1:		// Stop mode
		STA = 0x02;
		STA_Str = "Stop mode";
		break;
	case 2:		// Pre-Operation mode
		STA = 0x80;
		STA_Str = "Pre-Operation mode";
		break;
	case 3:		// Reset Node
		STA = 0x81;
		STA_Str = "Reset Node";
		break;
	case 4:		// Reset Communication
		STA = 0x82;
		STA_Str = "Reset Communication";
		break;
	}
}

void UserNMTErrISR() 
{
	WORD Ret;
	BYTE BoardNo, Node, Mode;
	NMTErr = "";

	Ret = CPM100_GetNMTError(&BoardNo, &Node, &Mode);
	if(!Ret){
		if(Mode == CPM_Node_Guarding_Event){
			NMTErr.Format(_T("Node %d Guarding Error"),Node);
		}
		else if(Mode == CPM_Heartbeat_Event){
			NMTErr.Format(_T("Node %d Heartbeat Error"),Node);
		}
	}
}

void UserEMCYISR() 
{
	BYTE BoardNo, Node, Data[8];
	WORD Ret;
	EMCY = "";

	Ret = CPM100_GetEMCYData(&BoardNo, &Node, Data);
	if(!Ret){
		EMCY.Format(_T("EMCY Node %d: %02X %02X %02X %02X %02X %02X %02X %02X"),Node,
			Data[0],Data[1],Data[2],Data[3],Data[4],Data[5],Data[6],Data[7]);
	}
}

void CNMT_ProtocolDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_InitMaster(BOARD, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		CPM100_InstallNMTErrISR(BOARD,UserNMTErrISR);
		CPM100_InstallEMCYISR(BOARD,UserEMCYISR);

		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_addnode.EnableWindow(TRUE);

		SetTimer(123,100,NULL);
	}
}

void CNMT_ProtocolDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_ShutdownMaster(BOARD);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		CPM100_RemoveNMTErrISR(BOARD);
		CPM100_RemoveEMCYISR(BOARD);

		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);

		Enable_Disable(FALSE);

		KillTimer(123);
	}
}

void CNMT_ProtocolDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_AddNode(BOARD, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_node.EnableWindow(FALSE);

		Enable_Disable(TRUE);
	}
}

void CNMT_ProtocolDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_RemoveNode(BOARD, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_node.EnableWindow(TRUE);

		Enable_Disable(FALSE);
	}
}

void CNMT_ProtocolDlg::OnButtonClear() 
{
	// TODO: Add your control notification handler code here
	m_reslist.ResetContent();
}

void CNMT_ProtocolDlg::OnButtonSetstate() 
{
	CString DataStr;
	// TODO: Add your control notification handler code here
	ret = CPM100_NMTChangeState(BOARD, NODE, STA, BlockMode);
	if(ret){
		errstr.Format(_T("Change Slave State Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("Change Slave State to %s OK"),STA_Str);
		m_reslist.AddString(DataStr);
	}
}

void CNMT_ProtocolDlg::OnButtonGuarding() 
{
	CString DataStr, TempStr;
	WORD n_GuardTimer, n_LifeTime;
	wchar_t *endstr;
	// TODO: Add your control notification handler code here

	m_guardtime.GetWindowText(TempStr);
	n_GuardTimer = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	m_lifetime.GetWindowText(TempStr);
	n_LifeTime = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	ret = CPM100_NMTGuarding(BOARD, NODE, n_GuardTimer, (BYTE)n_LifeTime, BlockMode);
	if(ret){
		errstr.Format(_T("Set Guarding Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("Set Guarding OK"));
		m_reslist.AddString(DataStr);
	}
}

void CNMT_ProtocolDlg::OnButtonHeartbeat() 
{
	CString DataStr, TempStr;
	WORD n_Heartbeat, n_Consumer;
	wchar_t *endstr;
	// TODO: Add your control notification handler code here

	m_heartbeat.GetWindowText(TempStr);
	n_Heartbeat = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	m_consumer.GetWindowText(TempStr);
	n_Consumer = (WORD)wcstol(TempStr.AllocSysString(),&endstr,10);

	ret = CPM100_NMTHeartbeat(BOARD, NODE, n_Heartbeat, n_Consumer, BlockMode);
	if(ret){
		errstr.Format(_T("Set Heartbeat Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		DataStr.Format(_T("Set Heartbeat OK"),STA_Str);
		m_reslist.AddString(DataStr);
	}
}

void CNMT_ProtocolDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	CPM100_ShutdownMaster(BOARD);
}

void CNMT_ProtocolDlg::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default
	if(NMTErr != ""){
		m_reslist.AddString(NMTErr);
		NMTErr = "";
	}

	if(EMCY != ""){
		m_reslist.AddString(EMCY);
		EMCY = "";
	}

	CDialog::OnTimer(nIDEvent);
}
