// PDO_MultiDataDlg.cpp : @
//

#include "stdafx.h"
#include "PDO_MultiData.h"
#include "PDO_MultiDataDlg.h"
#include "..\..\lib\cpm100u.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


//  App About ϥ CAboutDlg ܤ

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// ܤ
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 䴩

// {X@
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CPDO_MultiDataDlg ܤ


BYTE BOARD=0;
BYTE BAUD=0;
BYTE NODE=1;

BYTE BlockMode = 1;

WORD Id_List[10] = {0};
BYTE PDO_Cnt = 0;

WORD DelayTime=0;
WORD ret;
CString errstr;

CPDO_MultiDataDlg::CPDO_MultiDataDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPDO_MultiDataDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPDO_MultiDataDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_LIST_PDOLIST, m_pdolist);
	DDX_Control(pDX, IDC_COMBO_BOARD, m_board);
	DDX_Control(pDX, IDC_COMBO_NODE, m_node);
	DDX_Control(pDX, IDC_COMBO_BAUD, m_baud);
	DDX_Control(pDX, IDC_BUTTON_SHUTDOWN, m_btn_shutdown);
	DDX_Control(pDX, IDC_BUTTON_SETPOLLING, m_btn_setpolling);
	DDX_Control(pDX, IDC_BUTTON_SETTIMER, m_btn_settimer);
	DDX_Control(pDX, IDC_BUTTON_REMOVE, m_btn_removenode);
	DDX_Control(pDX, IDC_BUTTON_INITIAL, m_btn_initial);
	DDX_Control(pDX, IDC_BUTTON_ADDNODE, m_btn_addnode);
}

BEGIN_MESSAGE_MAP(CPDO_MultiDataDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DESTROY()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_CBN_SELCHANGE(IDC_COMBO_BAUD, OnSelchangeComboBaud)
	ON_CBN_SELCHANGE(IDC_COMBO_NODE, OnSelchangeComboNode)
	ON_CBN_SELCHANGE(IDC_COMBO_BOARD, OnSelchangeComboBoard)
	ON_BN_CLICKED(IDC_BUTTON_INITIAL, OnButtonInitial)
	ON_BN_CLICKED(IDC_BUTTON_SHUTDOWN, OnButtonShutdown)
	ON_BN_CLICKED(IDC_BUTTON_ADDNODE, OnButtonAddnode)
	ON_BN_CLICKED(IDC_BUTTON_REMOVE, OnButtonRemove)
	ON_BN_CLICKED(IDC_BUTTON_SETPOLLING, OnButtonSetpolling)
	ON_BN_CLICKED(IDC_BUTTON_SETTIMER, OnButtonSettimer)
END_MESSAGE_MAP()


// CPDO_MultiDataDlg TBz`

void CPDO_MultiDataDlg::Enable_Disable(bool Sta)
{
	if(Sta == FALSE){
		m_btn_setpolling.EnableWindow(FALSE);
		m_btn_settimer.EnableWindow(FALSE);
	}
	else{
		m_btn_setpolling.EnableWindow(TRUE);
		m_btn_settimer.EnableWindow(TRUE);
	}
}

BOOL CPDO_MultiDataDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// N [...] \[JtΥ\C

	// IDM_ABOUTBOX btΩROd򤧤C
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w

	for(WORD i=1;i<128;i++){
		CString Items;

		Items.Format(_T("%03d"), i);
		m_node.AddString(Items);
	}

	m_board.EnableWindow(TRUE);
	m_baud.EnableWindow(TRUE);
	m_node.EnableWindow(FALSE);

	m_btn_initial.EnableWindow(TRUE);
	m_btn_initial.ShowWindow(SW_SHOW);
	m_btn_shutdown.EnableWindow(TRUE);
	m_btn_shutdown.ShowWindow(SW_HIDE);
	m_btn_addnode.EnableWindow(FALSE);
	m_btn_addnode.ShowWindow(SW_SHOW);
	m_btn_removenode.EnableWindow(FALSE);
	m_btn_removenode.ShowWindow(SW_HIDE);

	Enable_Disable(FALSE);

	m_board.SetCurSel(0);
	m_baud.SetCurSel(0);
	m_node.SetCurSel(0);

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

void CPDO_MultiDataDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// pGN̤pƫs[JzܤAzݭnUC{XA
// HKøsϥܡCϥΤ/˵Ҧ MFC ε{A
// ج[|۰ʧ@~C

void CPDO_MultiDataDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // øs˸me

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NϥܸmΤݯx
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// yøϥ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// ϥΪ̩즲̤pƵɡA
// tΩIsoӥ\oܡC
HCURSOR CPDO_MultiDataDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CPDO_MultiDataDlg::OnSelchangeComboBoard() 
{
	// TODO: Add your control notification handler code here
	BOARD = m_board.GetCurSel();
}

void CPDO_MultiDataDlg::OnSelchangeComboBaud() 
{
	// TODO: Add your control notification handler code here
	BAUD = m_baud.GetCurSel();

	switch(BAUD){
	case 0:
		DelayTime = 15;
		break;
	case 1:
		DelayTime = 7;
		break;
	case 2:
		DelayTime = 3;
		break;
	case 3:
	case 4:
		DelayTime = 1;
		break;
	case 5:
	case 6:
	case 7:
		DelayTime = 0;
		break;
	}
}

void CPDO_MultiDataDlg::OnSelchangeComboNode() 
{
	// TODO: Add your control notification handler code here
	NODE = m_node.GetCurSel()+1;
}

void CPDO_MultiDataDlg::OnButtonInitial() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_InitMaster(BOARD, 0, BAUD, BlockMode);
	if(ret){
		errstr.Format(_T("Initial Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(FALSE);
		m_baud.EnableWindow(FALSE);
		m_node.EnableWindow(TRUE);

		m_btn_initial.ShowWindow(SW_HIDE);
		m_btn_shutdown.ShowWindow(SW_SHOW);
		m_btn_addnode.EnableWindow(TRUE);
	}
}

void CPDO_MultiDataDlg::OnButtonShutdown() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_ShutdownMaster(BOARD);
	if(ret){
		errstr.Format(_T("Shutdown Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_board.EnableWindow(TRUE);
		m_baud.EnableWindow(TRUE);
		m_node.EnableWindow(FALSE);

		m_btn_initial.ShowWindow(SW_SHOW);
		m_btn_shutdown.ShowWindow(SW_HIDE);

		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		m_node.SetCurSel(0);

		Enable_Disable(FALSE);

		KillTimer(123);
	}
}

void CPDO_MultiDataDlg::OnButtonAddnode() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_AddNode(BOARD, NODE, 1, DelayTime, 200, BlockMode);
	if(ret){
		errstr.Format(_T("AddNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(FALSE);
		m_btn_addnode.ShowWindow(SW_HIDE);
		m_btn_removenode.EnableWindow(TRUE);
		m_btn_removenode.ShowWindow(SW_SHOW);

		m_node.EnableWindow(FALSE);

		ret = CPM100_GetTxPDOID(BOARD, NODE, &PDO_Cnt, Id_List, BlockMode);
        if (ret != 0){
			errstr.Format(_T("GetTxPDOID Error, = %d"),ret);
            MessageBox(errstr,_T("Error"),MB_OK);

            Enable_Disable(FALSE);
        }
		else{
			Enable_Disable(TRUE);

            SetTimer(123, 100, NULL);
        }
	}
}

void CPDO_MultiDataDlg::OnButtonRemove() 
{
	// TODO: Add your control notification handler code here
	ret = CPM100_RemoveNode(BOARD, NODE, BlockMode);
	if(ret){
		errstr.Format(_T("RemoveNode Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
	}
	else{
		m_btn_addnode.EnableWindow(TRUE);
		m_btn_addnode.ShowWindow(SW_SHOW);
		m_btn_removenode.EnableWindow(FALSE);
		m_btn_removenode.ShowWindow(SW_HIDE);

		Enable_Disable(FALSE);

		KillTimer(123);
	}
}

void CPDO_MultiDataDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	CPM100_ShutdownMaster(BOARD);
}

void CPDO_MultiDataDlg::OnButtonSettimer()
{
	WORD i;

    ret = CPM100_SetPDORemotePolling(BOARD, 0, NULL, 0, BlockMode);  // Remove PDO-Polling 
    if (ret != 0){
		errstr.Format(_T("Stop TxPDO Polling Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
    }

    for (i = 0; i < PDO_Cnt; i++){
		ret = CPM100_PDOEventTimer(BOARD, Id_List[i], 500, BlockMode);
		if (ret != 0){
			errstr.Format(_T("The PDO %03X Not Support Event Timer"),Id_List[i]);
			MessageBox(errstr,_T("Error"),MB_OK);
        }
    }
}

void CPDO_MultiDataDlg::OnButtonSetpolling()
{
	WORD i;

    for (i = 0; i < PDO_Cnt; i++){
		ret = CPM100_PDOEventTimer(BOARD, Id_List[i], 0, BlockMode);  // Stop PDO Event Timer
        if (ret != 0){
			errstr.Format(_T("Stop The PDO %03X Event Timer Error, = %d"),Id_List[i],ret);
			MessageBox(errstr,_T("Error"),MB_OK);
        }
    }

    ret = CPM100_SetPDORemotePolling(BOARD, PDO_Cnt, Id_List, 100, BlockMode);
    if (ret != 0){
		errstr.Format(_T("Set Polling All TxPDO Error, = %d"),ret);
		MessageBox(errstr,_T("Error"),MB_OK);
    }
}

void CPDO_MultiDataDlg::OnTimer(UINT nIDEvent)
{
	WORD i, j;
    CString Temp_Str;

	BYTE *IsNew;
	BYTE *DLen;
	BYTE *Data;

	if(PDO_Cnt){
		IsNew = (BYTE*) malloc(PDO_Cnt);
		DLen = (BYTE*) malloc(PDO_Cnt);
		Data = (BYTE*) malloc(8 * PDO_Cnt);

		if((IsNew == NULL) || (DLen == NULL) || (Data == NULL)) return;

		memset(IsNew, 0, PDO_Cnt);
		memset(DLen, 0, PDO_Cnt);
		memset(Data, 0, 8 * PDO_Cnt);

		ret = CPM100_GetMultiPDOData(BOARD, PDO_Cnt, Id_List, IsNew, DLen, Data, 0);
		if (ret == 0){
			WORD startaddr = 0;

			m_pdolist.ResetContent();

			for (i = 0; i < PDO_Cnt; i++){
				Temp_Str.Format(_T("TxPDO %X : "),Id_List[i]);
				startaddr = (WORD)(i * 8);

				for (j = 0; j < DLen[i]; j++){
					Temp_Str.Format(_T("%s%02X "),Temp_Str, Data[startaddr + j]);
				}

				m_pdolist.AddString(Temp_Str);
			}
		}

		free(IsNew);
		free(DLen);
		free(Data);
	}

	CDialog::OnTimer(nIDEvent);
}